# Class HumanMatchEngine

java.lang.Object
uk.ac.starlink.table.join.HumanMatchEngine

All Implemented Interfaces:
  `MatchEngine`

public class HumanMatchEngine extends Object implements MatchEngine
MatchEngine adaptor which transforms the base engine so that it uses more human-friendly units. Currently, this means that it eschews radians in favour of degrees or arcseconds for angular quantities; it decides which on the basis of UCDs. In other respects, this engine will behave exactly the same as its base engine. If the base engine has no human-unfriendly units, this one should behave exactly the same.

Since:
  2 Sep 2005
Author:
  Mark Taylor

## Constructor Summary

Constructors
Constructor
Description
`HumanMatchEngine(MatchEngine baseEngine)`
Constructor.

## Method Summary

Modifier and Type
Method
Description
`Supplier<Coverage>`
`createCoverageFactory()`
Returns a supplier for coverage objects.
`Supplier<MatchKit>`
`createMatchKitFactory()`
Returns a factory for MatchKit instances corresponding to the current settings of this object.
`static MatchEngine`
`getHumanMatchEngine(MatchEngine base)`
Returns a human-friendly version of a supplied MatchEngine.
`uk.ac.starlink.table.DescribedValue[]`
`getMatchParameters()`
Returns a set of DescribedValue objects whose values can be modified to modify the matching criteria.
`uk.ac.starlink.table.ValueInfo`
`getMatchScoreInfo()`
Returns a description of the value returned by the `MatchKit.matchScore(Object[], Object[])` method.
`double`
`getScoreScale()`
Returns a scale value for the match score.
`uk.ac.starlink.table.DescribedValue[]`
`getTuningParameters()`
Returns a set of DescribedValue objects whose values can be modified to tune the performance of the match.
`uk.ac.starlink.table.ValueInfo[]`
`getTupleInfos()`
Returns a set of ValueInfo objects indicating what is required for the elements of each tuple.
`boolean`
`isIdentity()`
Indicates whether this object simply duplicates the underlying MatchEngine.
`boolean`
`isLargeAngle(uk.ac.starlink.table.ValueInfo info)`
Indicates whether a given value is recognised as representing a large angle (such as a coordinate of some kind).
`boolean`
`isSmallAngle(uk.ac.starlink.table.ValueInfo info)`
Indicates whether a given value is recognised as representing a small angle (such as an error of some kind).

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### HumanMatchEngine

public HumanMatchEngine(MatchEngine baseEngine)
Constructor.

Parameters:
  `baseEngine` - the match engine supplying the base behaviour for this one

## Method Details

### isIdentity

public boolean isIdentity()
Indicates whether this object simply duplicates the underlying MatchEngine.

Returns:
  true if this wrapper makes no changes to underlying behaviour, false if it may make changes

### getMatchParameters

public uk.ac.starlink.table.DescribedValue[] getMatchParameters()
Description copied from interface: `MatchEngine`
Returns a set of DescribedValue objects whose values can be modified to modify the matching criteria. Typically at least one of these will be some sort of tolerance separation which determines how close tuples must be to count as a match. This match engine's behaviour can be modified by calling `DescribedValue.setValue(Object)` on the returned objects.

Specified by:
  `getMatchParameters` in interface `MatchEngine`
Returns:
  array of described values which influence the match

### getTuningParameters

public uk.ac.starlink.table.DescribedValue[] getTuningParameters()
Description copied from interface: `MatchEngine`
Returns a set of DescribedValue objects whose values can be modified to tune the performance of the match. This match engine's performance can be influenced by calling `DescribedValue.setValue(Object)` on the returned objects.

Changing these values will make no difference to the output of `MatchKit.matchScore(Object[], Object[])`, but may change the output of `MatchKit.getBins(Object[])`. This may change the CPU and memory requirements of the match, but will not change the result. The default value should be something sensible, so that setting the value of these parameters is not in general required.

Specified by:
  `getTuningParameters` in interface `MatchEngine`
Returns:
  array of described values which may influence match performance

### getTupleInfos

public uk.ac.starlink.table.ValueInfo[] getTupleInfos()
Description copied from interface: `MatchEngine`
Returns a set of ValueInfo objects indicating what is required for the elements of each tuple. The length of this array is the number of elements in the tuple. Each element should at least have a defined name and content class. The info's `nullable` attribute has a special meaning: if true it means that it makes sense for this element of the tuple to be always blank (for instance assigned to no column).

Specified by:
  `getTupleInfos` in interface `MatchEngine`
Returns:
  array of objects describing the requirements on each element of the tuples used for matching

### createMatchKitFactory

public Supplier<MatchKit> createMatchKitFactory()
Description copied from interface: `MatchEngine`
Returns a factory for MatchKit instances corresponding to the current settings of this object.

The returned value is immutable, and is not affected by subsequent changes of the settings of this object.

Specified by:
  `createMatchKitFactory` in interface `MatchEngine`
Returns:
  match kit supplier

### createCoverageFactory

public Supplier<Coverage> createCoverageFactory()
Description copied from interface: `MatchEngine`
Returns a supplier for coverage objects. Each such coverage can be used to characterise a region of tuple space. When populated with a set of tuples A, any tuple for which the inclusion function defined by its `Coverage.createTestFactory()` method returns false is guaranteed not to match any tuple in A according to this object's match criteria.

The returned value is immutable, and is not affected by subsequent changes of the settings of this object.

If no suitable implementation is available, null may be returned.

Specified by:
  `createCoverageFactory` in interface `MatchEngine`
Returns:
  supplier of coverage objects, or null

### getScoreScale

public double getScoreScale()
Description copied from interface: `MatchEngine`
Returns a scale value for the match score. The intention is that the result of `matchScore`/`MatchEngine.getScoreScale()` is of order unity, and is thus comparable between different match engines.

As a general rule, the result should be the maximum value ever returned from the `matchScore` method, corresponding to the least good successful match. For binary MatchEngine implementations (all matches are either score=0 or failures) a value of 1 is recommended. If nothing reliable can be said about the scale, NaN may be returned.

Specified by:
  `getScoreScale` in interface `MatchEngine`
Returns:
  scale of successful match scores, a positive finite number or NaN

### getMatchScoreInfo

public uk.ac.starlink.table.ValueInfo getMatchScoreInfo()
Description copied from interface: `MatchEngine`
Returns a description of the value returned by the `MatchKit.matchScore(Object[], Object[])` method. The content class should be numeric (though need not be `Double`), and the name, description and units should be descriptive of whatever the physical significance of the value is. If the result of `matchScore` is not interesting (for instance, if it's always either 0 or -1), `null` may be returned.

Specified by:
  `getMatchScoreInfo` in interface `MatchEngine`
Returns:
  metadata for the match score results

### isLargeAngle

public boolean isLargeAngle(uk.ac.starlink.table.ValueInfo info)
Indicates whether a given value is recognised as representing a large angle (such as a coordinate of some kind).

Parameters:
  `info` - value metadata
Returns:
  true if info is known to represent a large angle

### isSmallAngle

public boolean isSmallAngle(uk.ac.starlink.table.ValueInfo info)
Indicates whether a given value is recognised as representing a small angle (such as an error of some kind).

Parameters:
  `info` - value metadata
Returns:
  true if info is known to represent a small angle

### getHumanMatchEngine

public static MatchEngine getHumanMatchEngine(MatchEngine base)
Returns a human-friendly version of a supplied MatchEngine. If no changes are required, the original instance is returned.

Parameters:
  `base` - original match engine
Returns:
  human-friendly version